(ns puppetlabs.activity.core
  (:require [puppetlabs.activity.postgres :refer [store-events!]]))

(defn- shiro-subject->map [get-subject subject]
  (let [login (.getPrincipal subject)]
    {:name login
     :id (:id (get-subject :login login))
     :type "users"})) ;; TODO in a future release this will be deduced from the call to get-subject

(defn report-activity! [db get-subject event-bundle]
  (let [event-bundle (update-in event-bundle [:commit :subject]
                                #(if (instance? org.apache.shiro.subject.Subject %)
                                   (shiro-subject->map get-subject %)
                                   %))]
    (store-events! db event-bundle)))
